function beliefs = infer_egbr(pots, W, mp_weight, graph_scale, transition_prob, N, usesql)

L = 2;
mu = graph_scale;
nu = 0.00;
mp_iters = 5;

% Make adjacency matrix
% Add edges connecting each label to next label
adj = zeros(N,N);
for i=1:(N-1);
    adj(i,i+1) = 1;
    adj(i+1,i) = 1;
end
edgeStruct = UGM_makeEdgeStruct(adj,2);

W = W + eye(size(W));

edgePot = zeros([L L edgeStruct.nEdges]);
edgePot = make_chain_edgepots(edgePot, edgeStruct, 1-transition_prob);

obs_pots = normalize_dist(pots .^ (1/(1+mp_weight)));

mp_post = ones([N, L]); 
for mp_iter = 1:mp_iters
    % Combine obs_pots and mp_post to form VE and run BP
    ve = normalize_dist(obs_pots .* mp_post);
%     mask = logical(repmat([repmat(0,1,5) repmat(1,1,5)],1,20));
%     mean(ve(mask,:));
    
    [bp_post,edgeBel,logZ] = UGM_Infer_Chain(ve,edgePot,edgeStruct);
    
    [mp_post,obj] = measure_prop(bp_post, W, mu, nu, usesql);
    mp_post = normalize_dist(mp_post .^ (mp_weight/(1+mp_weight)));
    
%     mask = logical(repmat([repmat(1,1,5) repmat(0,1,5)],1,20));
%     mean(mp_post(mask,:))
end

beliefs = mp_post;
