function beliefs = infer_lbp_model(pots, W, edge_weight, transition_prob, N)
L = 2;

% Make adjacency matrix
% Add edges connecting each label to next label (chain)
adj = zeros(N,N);
for i=1:(N-1);
    adj(i,i+1) = 1;
    adj(i+1,i) = 1;
end
% Add edges wherever W has a positive value
adj(W > 0) = 1;
edgeStruct = UGM_makeEdgeStruct(adj,2);

edgePot = zeros([L L edgeStruct.nEdges]);
edgePot = make_chain_edgepots(edgePot, edgeStruct, 1-transition_prob);
% Add potentials for long-range edges
sigmoid = @(z) 1.0 / (1.0 + exp(-z));
for e = 1:edgeStruct.nEdges;
   n1 = edgeStruct.edgeEnds(e,1);
   n2 = edgeStruct.edgeEnds(e,2);
   if ( abs(n1-n2) > 1 ) % if they are adjacent, this is a chain edge
       % otherwise, this is an edge from label to associated observation
       edge_prob = sigmoid(edge_weight * W(n1,n2));
       pot = [edge_prob (1-edge_prob); (1-edge_prob) edge_prob];
       edgePot(:,:,e) = pot;
   end
end

[beliefs,edgeBel,logZ] = UGM_Infer_LBP(pots,edgePot,edgeStruct);
% [beliefs,edgeBel,logZ] = UGM_Infer_Exact(pots,edgePot,edgeStruct);