function [p obj] = measure_prop(r, W, mu, nu, usesql)
% Relaxes the input distribution r according the measure propgation
% objective given the matrix W.  
% r -- N*L matrix specifying distribution for each node
% W -- N*N matrix specifying weight on each pair
% p -- N*L output matrix specifying distribution for each node

N = size(r, 1);
L = size(r, 2);

W = W + eye(size(W,1))*10;

% Write graph to file in MP graph format
graph_fname = tempname();
write_MP_graph(W, graph_fname);

% Write r to file in MP label format
label_fname = tempname();
write_MP_labels(r, label_fname);

% Write transduction file with everything observed
trans_fname = tempname();
write_MP_trans(N, trans_fname);

obj_fname = tempname();

post_fname = tempname();

if usesql;
    sql_arg = 'true';
else;
    sql_arg = 'false';
end


% cmd = sprintf('/Users/maxwl/Code/measureProp/MP_large_scale -inputGraphName %s -transductionFile %s -labelFile %s -outPosteriorFile %s -numClasses %d -mu %f -nu %f -nWinSize 1 -printAccuracy false -measureLabels true -maxIters %d -outObjFile %s', ...
cmd = sprintf('MP_large_scale -inputGraphName %s -transductionFile %s -labelFile %s -outPosteriorFile %s -numClasses %d -mu %f -nu %f -nWinSize 1 -printAccuracy false -measureLabels true -maxIters %d -outObjFile %s -useSQL %s', ...
  graph_fname, trans_fname, label_fname, post_fname, ...
  L, mu, nu, 50, obj_fname, sql_arg);
%fprintf(cmd)
%fprintf('\n')
[status, cmdout] = system(cmd);
%fprintf(cmdout)

p = read_MP_posts(post_fname);
obj = 0;

