function write_MP_graph(W, fname)
% Writes W to file in MP format
% W -- N*N weight matrix
% fname -- filename to write to

N = size(W, 1);

fid = fopen(fname, 'w');

% Write total number of nodes
fwrite(fid, N, 'uint32');

for i = 1:N;
    fwrite(fid, i-1, 'uint32'); % node index
    % TODO: write only those neighbors with nonzero weight?
    fwrite(fid, N, 'uint16'); % num neighbors
    for j = 1:N;
        fwrite(fid, j-1, 'uint32'); % neighbor index
        fwrite(fid, W(i,j), 'float'); % neighbor val
    end
end

fclose(fid);